<script setup lang="ts">
import VoteBox from '@/components/VoteBox.vue'
import { VoteInformation } from '@/scripts/types'
import { useDataStore } from '@/store/data'
import { onMounted, reactive } from 'vue'
import { useRouter } from 'vue-router'

const router = useRouter()
const data = useDataStore()

const state = reactive({
  search: ''
})

function searchFilter(v: VoteInformation) {
  const s = state.search.toLowerCase().trim()
  return `${v.id} ${v.title.toLowerCase().trim()}`.includes(s)
}

function refreshPage() {
  data.refreshVotes()
}

function voteSelected(voteIndex: number) {
  router.push(`/votes/${voteIndex}/teller-monitoring`)
  refreshPage()
}

onMounted(refreshPage)
</script>

<template>
    <div class="m-auto flex flex-col w-[50%]">
      <div class="flex justify-between">
        <h1 class="text-2xl">Sélection d'un vote</h1>
        <v-btn variant="text" color="primary" @click="refreshPage">Actualiser</v-btn>
      </div>
      <v-text-field
        density="compact"
        variant="solo"
        label="Recherche"
        append-inner-icon="mdi-magnify"
        single-line
        hide-details
        v-model="state.search"
      />
      <br />
      <div v-for="vote of data.votes.filter(searchFilter)" v-bind:key="vote.id">
        <v-hover>
          <template v-slot:default="{ isHovering, props }">
            <vote-box v-bind="props" :vote="vote" mode="info" class="my-2" :hover="isHovering" @click="() => voteSelected(vote.id)"/>
          </template>
        </v-hover>
      </div>
    </div>
</template>
